searchNodes=[{"ref":"Zippex.html","title":"Zippex","type":"module","doc":"A Generic Zipper implementation for Elixir. See Zippex.Zipper for usage."},{"ref":"Zippex.Context.html","title":"Zippex.Context","type":"module","doc":"The context of a Zipper. This module is used internally by Zippex and should not be accessed directly. The Context struct contains the following fields: parent - The parent of the focus node (or nil) ctx - The parent context (or nil) left - A list of left siblings of the focus node right - A list of right siblings of the focus node dirty - true iff the focus node or any of it&#39;s children have been modified"},{"ref":"Zippex.Context.html#path/2","title":"Zippex.Context.path/2","type":"function","doc":"Returns the path to the focus node."},{"ref":"Zippex.Context.html#t:element/0","title":"Zippex.Context.element/0","type":"type","doc":""},{"ref":"Zippex.Context.html#t:t/0","title":"Zippex.Context.t/0","type":"type","doc":""},{"ref":"Zippex.Meta.html","title":"Zippex.Meta","type":"module","doc":"The metadata of a Zipper. The Meta struct contains the following fields: is_branch - A function that receives a node and returns true if the node is a branch children - A function that receives a node and returns it&#39;s children make_node - A function that receives a node and a list of children and returns a new node"},{"ref":"Zippex.Meta.html#children/2","title":"Zippex.Meta.children/2","type":"function","doc":"Applies the children function on a node"},{"ref":"Zippex.Meta.html#is_branch/2","title":"Zippex.Meta.is_branch/2","type":"function","doc":"Applies the is_branch function on a node"},{"ref":"Zippex.Meta.html#make_node/3","title":"Zippex.Meta.make_node/3","type":"function","doc":"Applies the make_node function on a node and list of children"},{"ref":"Zippex.Meta.html#new/3","title":"Zippex.Meta.new/3","type":"function","doc":"Returns a new Meta struct"},{"ref":"Zippex.Meta.html#t:children_fun/0","title":"Zippex.Meta.children_fun/0","type":"type","doc":""},{"ref":"Zippex.Meta.html#t:element/0","title":"Zippex.Meta.element/0","type":"type","doc":""},{"ref":"Zippex.Meta.html#t:is_branch_fun/0","title":"Zippex.Meta.is_branch_fun/0","type":"type","doc":""},{"ref":"Zippex.Meta.html#t:make_node_fun/0","title":"Zippex.Meta.make_node_fun/0","type":"type","doc":""},{"ref":"Zippex.Meta.html#t:t/0","title":"Zippex.Meta.t/0","type":"type","doc":""},{"ref":"Zippex.Zipper.html","title":"Zippex.Zipper","type":"module","doc":"A Zipper is a representation of an aggregate data structure which allows it to be traversed and updated arbitrarily. This module implements tree-like semantics for traversing a data structure. Focus The current node of the zipper, also known as the focus node, can be retrieved by calling the focus/1 function. The following functions provide other information relating to the focus node: lefts - returns the left siblings of the focus node rights - returns the rights siblings of the focus node path - returns the path to the focus node from the root Traversal The focus can be moved using the following functions: head - moves to the root node down - moves to the first child of the focus node up - moves to the parent of the focus node left - moves to the left sibling of the focus node leftmost - moves to the leftmost sibling of the focus node right - moves to the right sibling of the focus node rightmost - moves to the rightmost sibling of the focus node next - moves to the next node in a depth-first traversal prev - moves to the previous node in a depth-first traversal Enumeration Zipper implements the Enumerable protocol, which allows it&#39;s values to be enumerated in a depth-first traversal. Updates The focus node can be modified using the functions edit/2 or edit/3. It can be removed, along with it&#39;s children, using the remove/1 function, after which the focus is moved to the previous node in a depth-first traversal."},{"ref":"Zippex.Zipper.html#down/1","title":"Zippex.Zipper.down/1","type":"function","doc":"Moves to the first child of the focus node. Returns the updated zipper, or nil if the focus node has no children."},{"ref":"Zippex.Zipper.html#edit/2","title":"Zippex.Zipper.edit/2","type":"function","doc":"Modifies the focus node by applying a function to it."},{"ref":"Zippex.Zipper.html#edit/3","title":"Zippex.Zipper.edit/3","type":"function","doc":"Modifies the focus node by applying a function to it."},{"ref":"Zippex.Zipper.html#focus/1","title":"Zippex.Zipper.focus/1","type":"function","doc":"Returns the focus node of a zipper."},{"ref":"Zippex.Zipper.html#head/1","title":"Zippex.Zipper.head/1","type":"function","doc":"Moves to the head of the zipper."},{"ref":"Zippex.Zipper.html#left/1","title":"Zippex.Zipper.left/1","type":"function","doc":"Moves to the left sibling of the focus node. Returns the updated zipper, or nil if the focus node has no left sibling."},{"ref":"Zippex.Zipper.html#leftmost/1","title":"Zippex.Zipper.leftmost/1","type":"function","doc":"Moves to the leftmost sibling of the focus node. Returns the updated zipper."},{"ref":"Zippex.Zipper.html#lefts/1","title":"Zippex.Zipper.lefts/1","type":"function","doc":"Returns the left siblings of the focus node."},{"ref":"Zippex.Zipper.html#new/4","title":"Zippex.Zipper.new/4","type":"function","doc":"Returns a new Zipper for a given node element. is_branch_fun receives a node and returns true if it is a branch, or false otherwise. children_fun receives a node (which is a branch) and returns a list of it&#39;s child nodes. make_node_fun receives a parent node and a list of child nodes and returns a new node."},{"ref":"Zippex.Zipper.html#next/1","title":"Zippex.Zipper.next/1","type":"function","doc":"Moves to the next node of the focus node in a depth-first traversal."},{"ref":"Zippex.Zipper.html#path/1","title":"Zippex.Zipper.path/1","type":"function","doc":"Returns the path to the focus node."},{"ref":"Zippex.Zipper.html#prev/1","title":"Zippex.Zipper.prev/1","type":"function","doc":"Moves to the previous node of the focus node in a depth-first traversal."},{"ref":"Zippex.Zipper.html#remove/1","title":"Zippex.Zipper.remove/1","type":"function","doc":"Removes the focus node, moving the focus to the node that would have preceded it in a depth-first traversal."},{"ref":"Zippex.Zipper.html#right/1","title":"Zippex.Zipper.right/1","type":"function","doc":"Moves to the right sibling of the focus node. Returns the updated zipper, or nil if the focus node has no right sibling."},{"ref":"Zippex.Zipper.html#rightmost/1","title":"Zippex.Zipper.rightmost/1","type":"function","doc":"Moves to the rightmost sibling of the focus node. Returns the updated zipper."},{"ref":"Zippex.Zipper.html#rights/1","title":"Zippex.Zipper.rights/1","type":"function","doc":"Returns the right siblings of the focus node."},{"ref":"Zippex.Zipper.html#root/1","title":"Zippex.Zipper.root/1","type":"function","doc":"Returns the root node of the zipper."},{"ref":"Zippex.Zipper.html#up/1","title":"Zippex.Zipper.up/1","type":"function","doc":"Moves to the parent of the focus node. Returns the updated zipper, or nil if the focus node has no parent."},{"ref":"Zippex.Zipper.html#t:args/0","title":"Zippex.Zipper.args/0","type":"type","doc":""},{"ref":"Zippex.Zipper.html#t:edit_fun/0","title":"Zippex.Zipper.edit_fun/0","type":"type","doc":""},{"ref":"Zippex.Zipper.html#t:edit_with_args_fun/0","title":"Zippex.Zipper.edit_with_args_fun/0","type":"type","doc":""},{"ref":"Zippex.Zipper.html#t:element/0","title":"Zippex.Zipper.element/0","type":"type","doc":""},{"ref":"Zippex.Zipper.html#t:t/0","title":"Zippex.Zipper.t/0","type":"type","doc":""},{"ref":"readme.html","title":"Zippex","type":"extras","doc":"Zippex A Zipper is a representation of an aggregate data structure which allows it to be traversed and updated arbitrarily. The Zippex.Zipper module provides a generic zipper for structures with tree-like semantics. Zippex is inspired by other zipper implementations, notably: clojure.zip - Clojure&#39;s zipper library inaka/zipper - A generic Zipper implementation in Erlang Exercism&#39;s Zipper exercise"},{"ref":"readme.html#installation","title":"Zippex - Installation","type":"extras","doc":"The package can be installed by adding zippex to your list of dependencies in mix.exs: def deps do [ {:zippex, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"readme.html#usage","title":"Zippex - Usage","type":"extras","doc":"The docs can be found at https://hexdocs.pm/zippex. Also see Zippex unit tests for usage examples."}]